# CfnStackSet

The `AWS::CloudFormation::StackSet` resource contains information about a StackSet.

With StackSets, you can provision stacks across AWS accounts and Regions from a single CloudFormation template. Each stack is based on the same CloudFormation template, but you can customize individual stacks using parameters.

> Run deployments to nested StackSets from the parent stack, not directly through the StackSet API.

Extends: Construct › CfnElement › CfnRefElement › CfnResource › CfnStackSet
Implements: IInspectable, ITaggable, IEnvironmentAware, IStackSetRef, IConstruct, IDependable

- CloudFormation: [`AWS::CloudFormation::StackSet`](https://docs.aws.amazon.com/AWSCloudFormation/latest/TemplateReference/aws-resource-cloudformation-stackset.html)
- Source: Generated code
- Type last changed: v2.252.0 · 30 Apr 2026

## Example

```ts
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_cloudformation as cloudformation } from 'aws-cdk-lib';

declare const managedExecution: any;
const cfnStackSet = new cloudformation.CfnStackSet(this, 'MyCfnStackSet', {
  permissionModel: 'permissionModel',
  stackSetName: 'stackSetName',

  // the properties below are optional
  administrationRoleArn: 'administrationRoleArn',
  autoDeployment: {
    dependsOn: ['dependsOn'],
    enabled: false,
    retainStacksOnAccountRemoval: false,
  },
  callAs: 'callAs',
  capabilities: ['capabilities'],
  description: 'description',
  executionRoleName: 'executionRoleName',
  managedExecution: managedExecution,
  operationPreferences: {
    concurrencyMode: 'concurrencyMode',
    failureToleranceCount: 123,
    failureTolerancePercentage: 123,
    maxConcurrentCount: 123,
    maxConcurrentPercentage: 123,
    regionConcurrencyType: 'regionConcurrencyType',
    regionOrder: ['regionOrder'],
  },
  parameters: [{
    parameterKey: 'parameterKey',
    parameterValue: 'parameterValue',
  }],
  stackInstancesGroup: [{
    deploymentTargets: {
      accountFilterType: 'accountFilterType',
      accounts: ['accounts'],
      accountsUrl: 'accountsUrl',
      organizationalUnitIds: ['organizationalUnitIds'],
    },
    regions: ['regions'],

    // the properties below are optional
    parameterOverrides: [{
      parameterKey: 'parameterKey',
      parameterValue: 'parameterValue',
    }],
  }],
  tags: [{
    key: 'key',
    value: 'value',
  }],
  templateBody: 'templateBody',
  templateUrl: 'templateUrl',
});
```

## Initializer

```ts
new CfnStackSet(scope: Construct, id: string, props: CfnStackSetProps)
```

## Construct Props

- `administrationRoleArn`: string | [IRoleRef](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_iam.IRoleRef.html) — The Amazon Resource Number (ARN) of the IAM role to use to create this StackSet.

  Specify an IAM role only if you are using customized administrator roles to control which users or groups can manage specific StackSets within the same administrator account.

  Use customized administrator roles to control which users or groups can manage specific StackSets within the same administrator account. For more information, see [Grant self-managed permissions](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/stacksets-prereqs-self-managed.html) in the *CloudFormation User Guide* .

  Valid only if the permissions model is `SELF_MANAGED` .

- `autoDeployment`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnStackSet.AutoDeploymentProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_cloudformation.CfnStackSet.AutoDeploymentProperty.html) — Describes whether StackSets automatically deploys to AWS Organizations accounts that are added to a target organization or organizational unit (OU).

  For more information, see [Enable or disable automatic deployments for StackSets in AWS Organizations](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/stacksets-orgs-manage-auto-deployment.html) in the *CloudFormation User Guide* .

  Required if the permissions model is `SERVICE_MANAGED` . (Not used with self-managed permissions.)

- `callAs`: string — Specifies whether you are acting as an account administrator in the organization's management account or as a delegated administrator in a member account.

  By default, `SELF` is specified. Use `SELF` for StackSets with self-managed permissions.

  - To create a StackSet with service-managed permissions while signed in to the management account, specify `SELF` .
  - To create a StackSet with service-managed permissions while signed in to a delegated administrator account, specify `DELEGATED_ADMIN` .

  Your AWS account must be registered as a delegated admin in the management account. For more information, see [Register a delegated administrator](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/stacksets-orgs-delegated-admin.html) in the *CloudFormation User Guide* .

  StackSets with service-managed permissions are created in the management account, including StackSets that are created by delegated administrators.

  Valid only if the permissions model is `SERVICE_MANAGED` .

- `capabilities`: string[] — The capabilities that are allowed in the StackSet.

  Some StackSet templates might include resources that can affect permissions in your AWS account —for example, by creating new IAM users. For more information, see [Acknowledging IAM resources in CloudFormation templates](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/control-access-with-iam.html#using-iam-capabilities) in the *CloudFormation User Guide* .

- `description`: string — A description of the StackSet.

- `executionRoleName`: string | [IRoleRef](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_iam.IRoleRef.html) — The name of the IAM execution role to use to create the StackSet.

  If you don't specify an execution role, CloudFormation uses the `AWSCloudFormationStackSetExecutionRole` role for the StackSet operation.

  Valid only if the permissions model is `SELF_MANAGED` .

  *Pattern* : `[a-zA-Z_0-9+=,.@-]+`

- `managedExecution`: any — Describes whether StackSets performs non-conflicting operations concurrently and queues conflicting operations.

  When active, StackSets performs non-conflicting operations concurrently and queues conflicting operations. After conflicting operations finish, StackSets starts queued operations in request order.

  > If there are already running or queued operations, StackSets queues all incoming operations even if they are non-conflicting.
  >
  > You can't modify your StackSet's execution configuration while there are running or queued operations for that StackSet.

  When inactive (default), StackSets performs one operation at a time in request order.

- `operationPreferences`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnStackSet.OperationPreferencesProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_cloudformation.CfnStackSet.OperationPreferencesProperty.html) — The user-specified preferences for how CloudFormation performs a StackSet operation.

- `parameters`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnStackSet.ParameterProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_cloudformation.CfnStackSet.ParameterProperty.html)[] — The input parameters for the StackSet template.

- `permissionModel`: string (required) — Describes how the IAM roles required for StackSet operations are created.

  - With `SELF_MANAGED` permissions, you must create the administrator and execution roles required to deploy to target accounts. For more information, see [Grant self-managed permissions](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/stacksets-prereqs-self-managed.html) in the *CloudFormation User Guide* .
  - With `SERVICE_MANAGED` permissions, StackSets automatically creates the IAM roles required to deploy to accounts managed by AWS Organizations . For more information, see [Activate trusted access for StackSets with AWS Organizations](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/stacksets-orgs-activate-trusted-access.html) in the *CloudFormation User Guide* .

- `stackInstancesGroup`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnStackSet.StackInstancesProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_cloudformation.CfnStackSet.StackInstancesProperty.html)[] — A group of stack instances with parameters in some specific accounts and Regions.

- `stackSetName`: string (required) — The name to associate with the StackSet.

  The name must be unique in the Region where you create your StackSet.

- `tags`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — Key-value pairs to associate with this stack.

  CloudFormation also propagates these tags to supported resources in the stack. You can specify a maximum number of 50 tags.

  If you don't specify this parameter, CloudFormation doesn't modify the stack's tags. If you specify an empty value, CloudFormation removes all associated tags.

- `templateBody`: string — The structure that contains the template body, with a minimum length of 1 byte and a maximum length of 51,200 bytes.

  You must include either `TemplateURL` or `TemplateBody` in a StackSet, but you can't use both. Dynamic references in the `TemplateBody` may not work correctly in all cases. It's recommended to pass templates that contain dynamic references through `TemplateUrl` instead.

- `templateUrl`: string — The URL of a file that contains the template body.

  The URL must point to a template (max size: 1 MB) that's located in an Amazon S3 bucket or a Systems Manager document. The location for an Amazon S3 bucket must start with `https://` .

  Conditional: You must specify only one of the following parameters: `TemplateBody` , `TemplateURL` .

## Properties

- `administrationRoleArn`: string — The Amazon Resource Number (ARN) of the IAM role to use to create this StackSet.

- `attrStackSetId`: string (required) — Returns the unique identifier of the resource.

- `autoDeployment`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnStackSet.AutoDeploymentProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_cloudformation.CfnStackSet.AutoDeploymentProperty.html) — Describes whether StackSets automatically deploys to AWS Organizations accounts that are added to a target organization or organizational unit (OU).

- `callAs`: string — Specifies whether you are acting as an account administrator in the organization's management account or as a delegated administrator in a member account.

- `capabilities`: string[] — The capabilities that are allowed in the StackSet.

- `CFN_RESOURCE_TYPE_NAME`: string (required) (static) — The CloudFormation resource type name for this resource class.

- `cfnOptions`: [ICfnResourceOptions](/cdk/api/v2/docs/aws-cdk-lib.ICfnResourceOptions.html) (required) — Options for this resource, such as condition, update policy etc.

- `cfnResourceType`: string (required) — AWS resource type.

- `creationStack`: string[] (required)

- `description`: string — A description of the StackSet.

- `env`: [ResourceEnvironment](/cdk/api/v2/docs/aws-cdk-lib.interfaces.ResourceEnvironment.html) (required)

- `executionRoleName`: string — The name of the IAM execution role to use to create the StackSet.

- `logicalId`: string (required) — The logical ID for this CloudFormation stack element.

  The logical ID of the element
  is calculated from the path of the resource node in the construct tree.

  To override this value, use `overrideLogicalId(newLogicalId)`.

- `managedExecution`: any (required) — Describes whether StackSets performs non-conflicting operations concurrently and queues conflicting operations.

- `node`: [Node](/cdk/api/v2/docs/constructs.Node.html) (required) — The tree node.

- `operationPreferences`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnStackSet.OperationPreferencesProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_cloudformation.CfnStackSet.OperationPreferencesProperty.html) — The user-specified preferences for how CloudFormation performs a StackSet operation.

- `parameters`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnStackSet.ParameterProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_cloudformation.CfnStackSet.ParameterProperty.html)[] — The input parameters for the StackSet template.

- `permissionModel`: string (required) — Describes how the IAM roles required for StackSet operations are created.

- `ref`: string (required) — Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

  If, by any chance, the intrinsic reference of a resource is not a string, you could
  coerce it to an IResolvable through `Lazy.any({ produce: resource.ref })`.

- `stack`: [Stack](/cdk/api/v2/docs/aws-cdk-lib.Stack.html) (required) — The stack in which this element is defined.

  CfnElements must be defined within a stack scope (directly or indirectly).

- `stackInstancesGroup`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnStackSet.StackInstancesProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_cloudformation.CfnStackSet.StackInstancesProperty.html)[] — A group of stack instances with parameters in some specific accounts and Regions.

- `stackSetName`: string (required) — The name to associate with the StackSet.

- `stackSetRef`: [StackSetReference](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_cloudformation.StackSetReference.html) (required) — A reference to a StackSet resource.

- `tags`: [TagManager](/cdk/api/v2/docs/aws-cdk-lib.TagManager.html) (required) — Tag Manager which manages the tags for this resource.

- `tagsRaw`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — Key-value pairs to associate with this stack.

- `templateBody`: string — The structure that contains the template body, with a minimum length of 1 byte and a maximum length of 51,200 bytes.

- `templateUrl`: string — The URL of a file that contains the template body.

## Methods

- `addDeletionOverride(path: string): void` — Syntactic sugar for `addOverride(path, undefined)`.

  **Parameters**

  - `path` — The path of the value to delete.

- `addDependency(target: CfnResource): void` — Use `addResourceDependency` instead.

  This method has been renamed to `addResourceDependency` to more clearly
  set it apart from `construct.node.addDependency`. See the documentation
  of that function for more details.

- `addDependsOn(target: CfnResource): void` — Use `addResourceDependency` instead.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method has been renamed to `addResourceDependency`, which makes it
  more clear that this method operates at a different level from the
  construct-level `construct.node.addDependency()` mechanism.

- `addMetadata(key: string, value: any): void` — Add a value to the CloudFormation Resource Metadata.

- `addOverride(path: string, value: any): void` — Adds an override to the synthesized CloudFormation resource.

  To add a
  property override, either use `addPropertyOverride` or prefix `path` with
  "Properties." (i.e. `Properties.TopicName`).

  If the override is nested, separate each nested level using a dot (.) in the path parameter.
  If there is an array as part of the nesting, specify the index in the path.

  To include a literal `.` in the property name, prefix with a `\`. In most
  programming languages you will need to write this as `"\\."` because the
  `\` itself will need to be escaped.

  For example,
  ```typescript
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
  ```
  would add the overrides
  ```json
  "Properties": {
    "GlobalSecondaryIndexes": [
      {
        "Projection": {
          "NonKeyAttributes": [ "myattribute" ]
          ...
        }
        ...
      },
      {
        "ProjectionType": "INCLUDE"
        ...
      },
    ]
    ...
  }
  ```

  The `value` argument to `addOverride` will not be processed or translated
  in any way. Pass raw JSON values in here with the correct capitalization
  for CloudFormation. If you pass CDK classes or structs, they will be
  rendered with lowercased key names, and CloudFormation will reject the
  template.

  **Parameters**

  - `path` — - The path of the property, you can use dot notation to override values in complex types.
  - `value` — - The value.

- `addPropertyDeletionOverride(propertyPath: string): void` — Adds an override that deletes the value of a property from the resource definition.

  **Parameters**

  - `propertyPath` — The path to the property.

- `addPropertyOverride(propertyPath: string, value: any): void` — Adds an override to a resource property.

  Syntactic sugar for `addOverride("Properties.<...>", value)`.

  **Parameters**

  - `propertyPath` — The path of the property.
  - `value` — The value.

- `addResourceDependency(target: CfnResource, reason?: string): void` — Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method only adds dependencies between L1 resources. If you are
  looking for a generic construct-to-construct dependency mechanism that works
  for all constructs including L2s, use `construct.node.addDependency` instead.

- `applyCrossStackReferenceStrength(strength: ReferenceStrength): void` — Sets the cross-stack reference strength for this resource.

  When set, any cross-stack reference to this resource will use the specified
  strength instead of the global default from the consuming stack's context.

  **Parameters**

  - `strength` — - The reference strength to use for this resource.

- `applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): void` — Sets the deletion policy of the resource based on the removal policy specified.

  The Removal Policy controls what happens to this resource when it stops
  being managed by CloudFormation, either because you've removed it from the
  CDK application or because you've made a change that requires the resource
  to be replaced.

  The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
  account for data recovery and cleanup later (`RemovalPolicy.RETAIN`). In some
  cases, a snapshot can be taken of the resource prior to deletion
  (`RemovalPolicy.SNAPSHOT`). A list of resources that support this policy
  can be found in the following link:

- `cfnPropertyName(cdkPropertyName: string): string`

- `getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Reference` — Returns a token for an runtime attribute of this resource.

  Ideally, use generated attribute accessors (e.g. `resource.arn`), but this can be used for future compatibility
  in case there is no generated attribute.

  **Parameters**

  - `attributeName` — The name of the attribute.

- `getMetadata(key: string): any` — Retrieve a value value from the CloudFormation Resource Metadata.

- `inspect(inspector: TreeInspector): void` — Examines the CloudFormation resource and discloses attributes.

  **Parameters**

  - `inspector` — tree inspector to collect and process attributes.

- `isCfnElement(x: any): boolean` (static) — Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

  Uses duck-typing instead of `instanceof` to allow stack elements from different
  versions of this library to be included in the same stack.

  **Returns:** The construct as a stack element or undefined if it is not a stack element.

- `isCfnResource(x: any): boolean` (static) — Check whether the given object is a CfnResource.

- `isCfnStackSet(x: any): boolean` (static) — Checks whether the given object is a CfnStackSet.

- `isConstruct(x: any): boolean` (static) — Checks if `x` is a construct.

  Use this method instead of `instanceof` to properly detect `Construct`
  instances, even when the construct library is symlinked.

  Explanation: in JavaScript, multiple copies of the `constructs` library on
  disk are seen as independent, completely different libraries. As a
  consequence, the class `Construct` in each copy of the `constructs` library
  is seen as a different class, and an instance of one class will not test as
  `instanceof` the other class. `npm install` will not create installations
  like this, but users may manually symlink construct libraries together or
  use a monorepo tool: in those cases, multiple copies of the `constructs`
  library can be accidentally installed, and `instanceof` will behave
  unpredictably. It is safest to avoid using `instanceof`, and using
  this type-testing method instead.

  **Parameters**

  - `x` — Any object.

  **Returns:** true if `x` is an object created from a class which extends `Construct`.

- `obtainDependencies(): Stack | CfnResource[]` — Retrieves an array of resources and stacks this resource depends on.

  For resources depended on directly, returns the `CfnResource` object. For
  dependencies on other stacks, returns the `Stack` object. The order of the
  array is not guaranteed.

- `overrideLogicalId(newLogicalId: string): void` — Overrides the auto-generated logical ID with a specific ID.

  **Parameters**

  - `newLogicalId` — The new logical ID to use for this stack element.

- `removeDependency(target: CfnResource): void` — Use `removeResourceDependency` instead

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `removeResourceDependency(target: CfnResource): void` — Indicates that this resource no longer depends on another resource.

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `replaceDependency(target: CfnResource, newTarget: CfnResource): void` — Replaces one dependency with another.

  **Parameters**

  - `target` — The dependency to replace.
  - `newTarget` — The new dependency to add.

- `toString(): string` — Returns a string representation of this construct.

  **Returns:** a string representation of this resource

- `with(...mixins: IMixin[]): IConstruct` — Applies one or more mixins to this construct.

  Mixins are applied in order. The list of constructs is captured at the
  start of the call, so constructs added by a mixin will not be visited.
  Use multiple `with()` calls if subsequent mixins should apply to added
  constructs.
